Unit IDS5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS5R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real;
                var H :Array of Real);

implementation

procedure IDS5R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real;
                var H :Array of Real);
var
K,N1,N2,J1,J2 :Integer;
H1,H2,R1,R2,W,U,V,Z :Real;
label
_1,_2,_3;
begin
N1 := N-1;
N2 := N1-1;
J1 := 1;
G[0] := 0.0;
F[0] := 0.0;
H[0] := -1.0;
H1 := X[N-1]-X[N1-1];
W := H1;
H2 := X[N1-1]-X[N2-1];
U := 2.0*(H1+H2);
R1 := (Y[N-1]-Y[N1-1])/H1;
R2 := (Y[N1-1]-Y[N2-1])/H2;
V := 6.0*(R1-R2);
for K:=1 to N1 do
 begin
  J2 := K+1;
  H2 := X[J2-1]-X[K-1];
  R2 := (Y[J2-1]-Y[K-1])/H2;
  if ( K = 1 ) 
   then goto _1;
  U := U-W*H[J1-1];
  V := V-W*F[J1-1];
  W := -G[J1-1]*W;
_1:
  Z := 1.0/(2.0*(H1+H2)-H1*G[J1-1]);
  G[K-1] := Z*H2;
  H[K-1] := -Z*H[J1-1]*H1;
  F[K-1] := Z*(6.0*(R2-R1)-H1*F[J1-1]);
  J1 := K;
  H1 := H2;
  R1 := R2;
_2:
 end;
H2 := W*H1;
H1 := (V-H2*F[N1-1])/(U-H2*(G[N1-1]+H[N1-1]));
Y2[N1-1] := H1;
for J1:=2 to N1 do
 begin
  K := N-J1;
  Y2[K-1] := F[K-1]-G[K-1]*Y2[K+0]-H[K-1]*H1;
_3:
 end;
Y2[N-1] := Y2[0];
end;

end.
